import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Color;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JFileChooser;
import javax.imageio.ImageIO;

/**
 * 16pYNX
 * <pre>
 * G[܂ł͍܂B
 * ςȂƂƁAG[ɂȂ܂B
 * ŃG[ꍞł݂Ăˁ
 * </pre>
 */
public class PZL16 {

	/** tF[Y */
	private		enum				PHASE { INIT, TITLE_WAIT, TILE_INIT, TILE_CHANGE, GAME_START, GAME, CLEAR, GAME_OVER };

	/** ^Cg */
	private final String			STR_TITLE			= "PUSH ANY BUTTON!";

	/** ^C */
	private final int				COUNT_ROW			= 4;
	private final int				COUNT_COL			= 4;

	/** ړJEgi^CړtF[Ypj */
	private final int				COUNT_MOVE			= 20;

	/** ^C̕E */
	protected static final int		WIDTH				= 96;
	protected static final int		HEIGHT				= 96;

	/** tHg */
	private final Font				FONT_80				= new Font(Font.DIALOG, Font.BOLD, 80);

	/** t[ */
	private		JFrame				frame				= null;
	/** Rei */
	private		Container			con					= null;

	/** ^C */
	private		PZLButton[][]		btnss				= null;
	private		BufferedImage[][]	imageBtnss			= null;

	/** j[ */
	private		JMenuBar			menuBar				= null;
	private		JButton				btnImage			= null;
	private		JTextField			fldCount			= null;
	private		JLabel				lblCount			= null;
	private		JButton				btnGiveUp			= null;

	/** bZ[W */
	private		JLabel				lblMessage			= null;

	/** ʉ */
	private		KSoundWave			waveOK				= null;
	private		KSoundWave			waveNG				= null;
	private		KSoundWave			waveClear			= null;

	/** tF[Y */
	private		PHASE				phase				= PHASE.INIT;
	/**  */
	private		int					time				= 0;

	/** ^C}[ */
	private		Timer				timer				= null;

	/** ړJEgi^CړtF[Ypj */
	private		int					countMove			= COUNT_MOVE;
	/** ړJEgi[vpj */
	private		int					countMoveLoop		= 0;
	/** uN^Cʒui^CړtF[Ypj */
	private		int					col0				= COUNT_COL - 1;
	private		int					row0				= COUNT_ROW - 1;

	/** uN^C̔ԍ */
	private		int					countTile			= -1;

	/** C[Wt@CpX */
	private		String				strPathImage		= null;

	/**
	 * n܂܂B
	 */
	public static void main(String[] args){
		PZL16 pzl16 = new PZL16();
		pzl16.run();
	} // end main

	/**
	 * RXgN^
	 */
	public PZL16(){

		// t[𐶐
		frame = new JFrame("PZL16");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setResizable(false);

		// Rei擾
		con = frame.getContentPane();

		// CAEgݒ
		con.setLayout(null);

		// j[쐬
		menuBar = new JMenuBar();

		btnImage = new JButton("摜I");
		menuBar.add(btnImage);
		btnImage.addActionListener(ae -> selectImage());

		fldCount = new JTextField(Integer.toString(COUNT_MOVE));
		fldCount.setHorizontalAlignment(JTextField.RIGHT);
		menuBar.add(fldCount);

		lblCount = new JLabel("  ");
		menuBar.add(lblCount);

		btnGiveUp = new JButton("MuAbvI");
		menuBar.add(btnGiveUp);
		btnGiveUp.addActionListener(ae -> phase = PHASE.INIT);

		// j[ݒ
		frame.setJMenuBar(menuBar);

		// bZ[Wx쐬
		lblMessage = new JLabel(" START!! ");
		lblMessage.setFont(new Font(Font.DIALOG, Font.BOLD, 40));
		lblMessage.setForeground(Color.RED);
		lblMessage.setHorizontalAlignment(JLabel.CENTER);
		con.add(lblMessage);
		lblMessage.setVisible(false);
		lblMessage.setBounds(0, COUNT_ROW * HEIGHT / 2 - 24, COUNT_COL * WIDTH, 48);

		// ^C𐶐
		btnss = new PZLButton[COUNT_COL][COUNT_ROW];

		// }EXA_v^𐶐
		PZL16MouseAdapter ma = new PZL16MouseAdapter();

		// ^CA[v
		for(int row = 0; row < COUNT_ROW; row++){
			for(int col = 0; col < COUNT_COL; col++){

				// ^C𐶐
				btnss[col][row] = new PZLButton();

				// tHgݒ
				btnss[col][row].setFont(FONT_80);

				// ^Czu
				con.add(btnss[col][row]);

				// Xi[𐶐
				btnss[col][row].addMouseListener(ma);

			} // end for ^CA[v
		} // end for ^CA[v

		// TCYœKȃTCYɐݒ
		con.setPreferredSize(new Dimension(COUNT_COL * WIDTH + 1, COUNT_ROW * HEIGHT + 1));
		frame.pack();

		// \
		frame.setVisible(true);

		// ݂̃pX擾
		String strPath = new File(".").getAbsoluteFile().getParent();

		// C[Wt@CpX
		strPathImage = strPath + File.separator + "000_Dummy.png";

		// 摜
		createImage();

		// ʉ𐶐
		waveOK = new KSoundWave(this, "SE02.wav", false);
		waveNG = new KSoundWave(this, "SE03.wav", false);
		waveClear = new KSoundWave(this, "CLEAR.wav", false);

		// ^C}[𐶐
		timer = new Timer();
		// ^C}[X^[g
		timer.scheduleAtFixedRate(new PZL16TimerTask(), 1, 16);

	} // end PZL16

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// tF[Yɕ
		switch(phase){

			// 
			case INIT:

				// CfbNX
				int index = 0;

				// ^CA[v
				for(int row = 0; row < COUNT_ROW; row++){
					for(int col = 0; col < COUNT_COL; col++){

						try{
							// ݒ
							btnss[col][row].setText(STR_TITLE.substring(index, index + 1));
						}catch(StringIndexOutOfBoundsException oe){
						}

						// C[W
						btnss[col][row].setImage(null);

						// CfbNX{P
						index++;

						// ^Cʒuݒ
						btnss[col][row].setBounds(col * WIDTH, row * HEIGHT, WIDTH, HEIGHT);

					} // end for ^CA[v
				} // end for ^CA[v

				// uN^C̔ԍ擾
				countTile = COUNT_ROW * COUNT_COL - 1;

				// Ԃ
				time = 0;

				// tF[Y^Cg
				phase = PHASE.TITLE_WAIT;

				// uCN
				break;

			// ^Cg
			case TITLE_WAIT:

				// }EXNbN\bhŏ̂ŁAł͉Ȃ

				// uCN
				break;

			// ^C
			case TILE_INIT:

				// ^CA[v
				for(int row = 0; row < COUNT_ROW; row++){
					for(int col = 0; col < COUNT_COL; col++){

						// 폜
						btnss[col][row].setText(null);

						// ԍݒ
						btnss[col][row].setNo(row * COUNT_COL + col);

						// C[W\t
						btnss[col][row].setImage(imageBtnss[col][row]);

					} // end for ^CA[v
				} // end for ^CA[v

				// ړJEgi^CړtF[Ypj擾
				// ȊO͂ĂAftHg̃JEgɏ㏑
				countMove = COUNT_MOVE;
				try{
					countMove = Integer.parseInt(fldCount.getText());
				}catch(Exception ex){
					fldCount.setText(Integer.toString(COUNT_MOVE));
				}

				// ړJEgi[vpj
				countMoveLoop = 0;

				// uN^Cʒui^CړtF[Ypj
				col0 = COUNT_COL - 1;
				row0 = COUNT_ROW - 1;

				// Ԃ
				time = 0;

				// tF[Y^Cړ
				phase = PHASE.TILE_CHANGE;

				// uCN
				break;

			// ^Cړ
			case TILE_CHANGE:

				// ԂA
				if(time % 4 == 0){

					// ^Cړ
					changeTile();

					// ړJEgi[vpj{P
					countMoveLoop++;

					// ړIꍇA
					if(countMoveLoop >= countMove){

						// Ԃ
						time = 0;

						// tF[YQ[X^[g
						phase = PHASE.GAME_START;

					}

				} // end if Ԃ

				// uCN
				break;

			// Q[X^[g
			case GAME_START:

				// 0.5bA
				if(time < 30){

					// Ȃ

				// 0.5bA
				}else if(time == 30){

					// X^[g\
					lblMessage.setText(" START!! ");
					lblMessage.setVisible(true);

				// 2.0bA
				}else if(time < 120){

					// Ȃ

				// 2.0bA
				}else if(time == 120){

					// X^[g\
					lblMessage.setVisible(false);

					// Ԃ
					time = 0;

					// tF[YQ[
					phase = PHASE.GAME;

				}

				// uCN
				break;

			// Q[
			case GAME:

				// Ԃ\
				frame.setTitle("PZL16  " + (time / 60) + "bo߁I");

				// uCN
				break;

			// NA
			case CLEAR:

				// 1bA
				if(time < 60){

					// Ȃ

				// 1bA
				}else if(time == 60){

					// NA\
					lblMessage.setText(" CLEAR!! ");
					lblMessage.setVisible(true);

					// ʉX^[g
					waveClear.start();

				// 4bA
				}else if(time < 240){

					// Ȃ

				// 4bA
				}else{

					// NA\
					lblMessage.setVisible(false);

					// Ԃ
					time = 0;

					// tF[Y
					phase = PHASE.INIT;

				}

				// uCN
				break;

			// ftHg
			default:

				// uCN
				break;

		} // end swith tF[Yɕ

	} // end run

	/**
	 * }EXA_v^
	 */
	private class PZL16MouseAdapter extends MouseAdapter {

		/**
		 * Cxg
		 * <pre>
		 * NbNCxĝ߂ɁACxg܂B
		 * X[p[NX̃NbNCxgł͍s܂B
		 * ƗɁA}EẌʒȕłꂪƁA
		 * NbNCxgȂ߁AƎɗCxg܂B
		 * </pre>
		 */
		@Override
		public void mouseReleased(MouseEvent me){

			// X[p[NX̃\bhĂяo
			super.mouseReleased(me);

			// IuWFNg擾
			PZLButton btn = (PZLButton)me.getSource();
			// ʒu擾
			int x = me.getX();
			int y = me.getY();

			// ʒuA^C̏ꍇA
			if(x >= 0 && x < btn.getWidth() && y >= 0 && y < btn.getHeight()){

				// NbNCxg
				mouseClicked(btn.getX() / WIDTH, btn.getY() / HEIGHT);

			} // end if ʒuA^C̏ꍇ

		} // end mouseReleasseed

		/**
		 * NbNCxg
		 * <pre>
		 * ^Cʒuœn悤ɁAƎɃNbNCxg܂B
		 * </pre>
		 * @param row s
		 * @param col 
		 */
		public void mouseClicked(int col, int row){

System.out.println("NbN" + phase + " COL:" + col + " / ROW:" + row);

			// tF[Yɕ
			switch(phase){

				// ^Cg
				case TITLE_WAIT:

					// Ԃ
					time = 0;

					// tF[Y^C
					phase = PHASE.TILE_INIT;

					// uCN
					break;

				// Q[
				case GAME:

					// ^ĂȂtO
					boolean flgMoved = false;

					//
					// 
					//

					// [玩̂Ƃ܂ŁA[v
					for(int rowCheck = 0; rowCheck < row; rowCheck++){ 

						// ^C擾
						PZLButton btn = btnss[col][rowCheck];

						// uN̏ꍇA
						if(btn.getNo() == countTile){

							// 
							flgMoved = true;

							// Xbv
							swap(btn, btnss[col][rowCheck + 1]);

						}

					} // end for  [玩̂Ƃ܂ŁA[v

					//
					// 
					//

					// [玩̂Ƃ܂ŁA[v
					for(int rowCheck = COUNT_ROW - 1; rowCheck > row; rowCheck--){ 

						// ^C擾
						PZLButton btn = btnss[col][rowCheck];

						// uN̏ꍇA
						if(btn.getNo() == countTile){

							// 
							flgMoved = true;

							// Xbv
							swap(btn, btnss[col][rowCheck - 1]);

						}

					} // end for  [玩̂Ƃ܂ŁA[v

					//
					// 
					//

					// [玩̂Ƃ܂ŁA[v
					for(int colCheck = 0; colCheck < col; colCheck++){ 

						// ^C擾
						PZLButton btn = btnss[colCheck][row];

						// uN̏ꍇA
						if(btn.getNo() == countTile){

							// 
							flgMoved = true;

							// Xbv
							swap(btn, btnss[colCheck + 1][row]);

						}

					} // end for  [玩̂Ƃ܂ŁA[v

					//
					// E
					//

					// [玩̂Ƃ܂ŁA[v
					for(int colCheck = COUNT_COL - 1; colCheck > col; colCheck--){ 

						// ^C擾
						PZLButton btn = btnss[colCheck][row];

						// uN̏ꍇA
						if(btn.getNo() == countTile){

							// 
							flgMoved = true;

							// ^C Xbv
							swap(btn, btnss[colCheck - 1][row]);

						}

					} // end for  [玩̂Ƃ܂ŁA[v

					// ^CړꍇA
					if(flgMoved){

						// ĕ`
						con.repaint();

						// tO
						boolean flgJun = true;

						// ʉX^[g
						waveOK.start();

						// ^CA[v
						for(int rowJun = 0; rowJun < COUNT_ROW; rowJun++){
							for(int colJun = 0; colJun < COUNT_COL; colJun++){

								// ^C擾
								PZLButton btn = btnss[colJun][rowJun];

								// NołȂꍇA
								if(btn.getNo() != rowJun * COUNT_COL + colJun){

									// tO|łȂ
									flgJun = false;

									// uCN
									break;

								} // end if NołȂꍇ

							} // end for ^CA[v

							// tO|łȂꍇA
							if(!flgJun){
								// uCN
								break;
							}

						} // end for ^CA[v

						// tO|łꍇA
						if(flgJun){

							// Ԃ
							time = 0;

							// tF[YNA
							phase = PHASE.CLEAR;

						}

					// ^CړȂꍇA
					}else{

						// ʉX^[g
						waveNG.start();

					} // end if ^CړȂꍇ

					// uCN
					break;

				// ftHg
				default:

					// uCN
					break;

			} // end swith tF[Yɕ

		} // end mouseClicked

	} // end PZL16MouseAdapter

	/**
	 * 摜I
	 */
	private void selectImage(){

		// ݂̃pX擾
		String strPath = new File(".").getAbsoluteFile().getParent();

		// t@CI_CAO𐶐
		JFileChooser fileChhser = new JFileChooser(strPath);

		// t@CI_CAO\
		int option = fileChhser.showOpenDialog(frame);

		// IȊȌꍇA
		if(option != JFileChooser.APPROVE_OPTION){
			// ^[
			return;
		}

		// It@C
		File fileImage = fileChhser.getSelectedFile();

		// C[Wt@CpX
		strPathImage = fileImage.getAbsolutePath();

		// 摜
		createImage();

	} // selectImage

	/**
	 * 摜
	 */
	private void createImage(){

		try{

			// C[W擾
			BufferedImage image = ImageIO.read(new File(strPathImage));

			// TCY擾
			int width = image.getWidth();
			int height = image.getHeight();

			// C[WꍇA
			if(width < 80 || height < 80){
				// bZ[W\
				JOptionPane.showMessageDialog(frame, "sNZ80ȏɂĂB");
				// ^[
				return;
			}

			// ^CTCY
			int widthButton = width / COUNT_COL;
			int heightButton = height / COUNT_ROW;

			// ^C̉摜̊i[IuWFNg
			imageBtnss = new BufferedImage[COUNT_COL][COUNT_ROW];

			// ^CA[v
			for(int row = 0; row < COUNT_ROW; row++){
				for(int col = 0; col < COUNT_COL; col++){

					// ^C̑̉摜i[
					imageBtnss[col][row] = image.getSubimage(col * widthButton, row * heightButton, widthButton, heightButton);

				} // end for ^CA[v
			} // end for ^CA[v

			// Ō̃^C͉摜ȂƂ
			imageBtnss[COUNT_COL - 1][COUNT_ROW - 1] = null;

		}catch(Exception ex){

			throw new RuntimeException(ex);

		}

	} // end createImage

	/**
	 * ^C Xbv
	 */
	private void swap(PZLButton btn0, PZLButton btn1){ 

		// ReïʒuύX
		Point point0 = btn0.getLocation();
		Point point1 = btn1.getLocation();

		btn0.setLocation(point1);
		btn1.setLocation(point0);

		// z̈ʒuύX
		int col0 = point0.x / WIDTH;
		int row0 = point0.y / HEIGHT;
		int col1 = point1.x / WIDTH;
		int row1 = point1.y / HEIGHT;

		btnss[col0][row0] = btn1;
		btnss[col1][row1] = btn0;

	} // end swap

	/**
	 * ^Cړ
	 */
	private void changeTile(){

		// ړ^C
		int col1 = 0;
		int row1 = 0;

		// ړ^C܂܂Ń[v
		while(true){

			// ړ^C
			col1 = col0;
			row1 = row0;

			// 
			double h = Math.random();
			if(h < 0.25){
				col1--;
			}else if(h < 0.50){
				col1++;
			}else if(h < 0.75){
				row1--;
			}else{
				row1++;
			}

			// ͈͓̏ꍇA
			if(0 <= col1 && col1 < COUNT_COL && 0 <= row1 && row1 < COUNT_ROW){
				// uCN
				break;
			}

		} // end while ړ^C܂܂Ń[v

		// ^C Xbv
		swap(btnss[col0][row0], btnss[col1][row1]);

		// uN^C̈ʒuݒ
		col0 = col1;
		row0 = row1;

	} // end changeTile

	/**
	 * ^C}[NX
	 */
	private class PZL16TimerTask extends TimerTask {

		public void run(){

			// s\bhĂяo
			PZL16.this.run();

		} // end actionPerformed

	} // end PZL16TimerTask

}
